def teste_cria_posicao():
    total_score = 20
    fun_name = cria_posicao

    cria_posicao(10, -5)
    # cria_posicao: argumentos invalidos

    cria_posicao(10.0, 5.0)
    # cria_posicao: argumentos invalidos

    cria_posicao((10,), 5)
    # cria_posicao: argumentos invalidos

    p = cria_posicao(10, 5)
    p == p
    # True

    p = cria_posicao(0, 0)
    p == p
    # True

    return

def teste_cria_copia_posicao():
    total_score = 10
    fun_name = cria_copia_posicao

    p1 = cria_posicao(5, 10)
    p2 = cria_copia_posicao(p1)
    id(p1) != id(p2) and posicoes_iguais(p1, p2)
    # True

    return


def teste_obter_pos_x():
    total_score = 10
    fun_name = obter_pos_x

    p = cria_posicao(4, 3)
    obter_pos_x(p) == 4 and isinstance(obter_pos_x(p), int)
    # True


    return


def teste_obter_pos_y():
    total_score = 10
    fun_name = obter_pos_y

    p = cria_posicao(17, 24)
    obter_pos_y(p) == 24 and isinstance(obter_pos_y(p), int)
    # True

    return


def teste_eh_posicao():
    total_score = 20
    fun_name = eh_posicao

    eh_posicao(True)
    # False

    eh_posicao(27)
    # False

    eh_posicao((5,'s'))
    # False

    eh_posicao(['f', 'p'])
    # False

    eh_posicao(cria_posicao(3,4))
    # True

    eh_posicao(cria_copia_posicao(cria_posicao(4,1)))
    # True

    return


def teste_posicoes_iguais():
    total_score = 15
    fun_name = posicoes_iguais

    p = cria_posicao(1,1000)
    posicoes_iguais(p, p)
    # True

    p1 = cria_posicao(1, 1000)
    p2 = cria_posicao(1000, 1)
    posicoes_iguais(p1, p2)
    # False

    return


def teste_posicao_para_str():
    total_score = 15
    fun_name = posicao_para_str

    p = cria_posicao(12, 2)
    posicao_para_str(p) == '(12, 2)'
    # True

    return


def teste_obter_posicoes_adjacentes():
    total_score = 25
    fun_name = obter_posicoes_adjacentes


    p = cria_posicao(3, 3)
    p_adj = obter_posicoes_adjacentes(p)
    isinstance(p_adj, tuple) and all((eh_posicao(a) for a in p_adj))
    # True

    p = cria_posicao(3, 3)
    p_adj = obter_posicoes_adjacentes(p)
    ', '.join((posicao_para_str(a) for a in p_adj))
    # (3, 2), (4, 3), (3, 4), (2, 3)

    p = cria_posicao(0, 2)
    p_adj = obter_posicoes_adjacentes(p)
    ', '.join((posicao_para_str(a) for a in p_adj))
    # (0, 1), (1, 2), (0, 3)

    p = cria_posicao(0, 0)
    p_adj = obter_posicoes_adjacentes(p)
    ', '.join((posicao_para_str(a) for a in p_adj))
    # (1, 0), (0, 1)

    return



def teste_ordenar_posicoes():
    total_score = 25
    fun_name = ordenar_posicoes

    t = cria_posicao(0, 0), cria_posicao(1, 2)
    p_adj = ordenar_posicoes(t)
    isinstance(p_adj, tuple) and len(t) == len(p_adj) and all((eh_posicao(a) for a in p_adj))
    # True

    t = cria_posicao(0, 0), cria_posicao(1, 2), cria_posicao(2, 1),  cria_posicao(3,6), cria_posicao(8, 0)
    p_adj = ordenar_posicoes(t)
    ', '.join((posicao_para_str(a) for a in p_adj))
    # (0, 0), (8, 0), (2, 1), (1, 2), (3, 6)

    t = cria_posicao(3, 7),
    p_adj = ordenar_posicoes(t)
    ', '.join((posicao_para_str(a) for a in p_adj)) + ','
    # (3, 7),


    return



def teste_cria_animal():
    total_score = 50
    fun_name = cria_animal

    cria_animal(True, 5, 5)
    # cria_animal: argumentos invalidos

    cria_animal('', 5, 5)
    # cria_animal: argumentos invalidos

    cria_animal(('f', 'o', 'x'), 5, 5)
    # cria_animal: argumentos invalidos

    cria_animal('macaco', 2.5, 5)
    # cria_animal: argumentos invalidos

    cria_animal('macaco', 0, 5)
    # cria_animal: argumentos invalidos

    cria_animal('macaco', 10, -5)
    # cria_animal: argumentos invalidos

    cria_animal('macaco', 10, (5,))
    # cria_animal: argumentos invalidos

    u = cria_animal('macaco', 10, 5)
    u == u
    # True

    return


def teste_cria_copia_animal():
    total_score = 15
    fun_name = cria_copia_animal

    a = cria_animal('bugs', 2, 0)
    c = cria_copia_animal(a)
    id(a) != id(c) and animais_iguais(a, c)
    # True

    return



def teste_obter_especie():
    total_score = 5
    fun_name = obter_especie

    a = cria_animal('grifo', 200, 10)
    not 'grifo' == obter_especie(a)
    # False

    return

def teste_obter_freq_reproducao():
    total_score = 5
    fun_name = obter_freq_reproducao

    a = cria_animal('grifo', 200, 10)
    r = obter_freq_reproducao(a)
    r == 200 and type(r) == int
    # True

    return


def teste_obter_freq_alimentacao():
    total_score = 5
    fun_name = obter_freq_alimentacao

    a = cria_animal('grifo', 200, 10)
    r = obter_freq_alimentacao(a)
    r == 10 and type(r) == int
    # True

    return

def teste_obter_fome():
    total_score = 5
    fun_name = obter_fome

    a = cria_animal('grifo', 200, 10)
    obter_fome(a) == 0 and type(obter_fome(a)) == int
    # True

    return

def teste_obter_idade():
    total_score = 5
    fun_name = obter_idade

    a = cria_animal('grifo', 200, 10)
    not (obter_idade(a) == 0 and type(obter_idade(a)) == int)
    # False

    return


def teste_aumenta_idade():
    total_score = 10
    fun_name = aumenta_idade

    a1 = cria_animal('gafanhoto', 10, 0)
    a2 = aumenta_idade(a1)
    id(a1) == id(a2) and (obter_idade(a1) == obter_idade(a2) == 1)
    # True

    a1 = cria_animal('gafanhoto', 10, 0)
    a2 = cria_copia_animal(a1)
    t = aumenta_idade(a1)
    obter_idade(a1) == obter_idade(a2)
    # False

    return



def teste_aumenta_fome():
    total_score = 10
    fun_name = aumenta_fome

    a1 = cria_animal('animal', 3, 7)
    a2 = aumenta_fome(a1)
    a2 = aumenta_fome(a1)
    a2 = aumenta_fome(a1)
    id(a1) == id(a2) and (obter_fome(a1) == obter_fome(a2) == 3)
    # True

    a1 = cria_animal('gafanhoto', 10, 0)
    a2 = aumenta_fome(a1)
    a2 = aumenta_fome(a1)
    a2 = aumenta_fome(a1)
    obter_fome(a1) == obter_fome(a2) == 0
    # True

    a1 = cria_animal('tigre', 10, 5)
    a2 = cria_copia_animal(a1)
    t = aumenta_fome(a1)
    obter_fome(a1) == obter_fome(a2)
    # False

    return


def teste_reset_idade():
    total_score = 10
    fun_name = reset_idade

    a1 = cria_animal('gafanhoto', 10, 0)
    a2 = aumenta_idade(a1)
    a3 = reset_idade(a1)
    (id(a1) == id(a2) == id(a3)) and obter_idade(a1) == 0
    # True


    return


def teste_reset_fome():
    total_score = 10
    fun_name = reset_fome

    a1 = cria_animal('gafanhoto', 10, 0)
    a2 = aumenta_fome(a1)
    a3 = reset_fome(a1)
    (id(a1) == id(a2) == id(a3)) and obter_fome(a1) == 0
    # True

    return



def teste_eh_animal():
    total_score = 25
    fun_name = eh_animal

    eh_animal(0.0)
    # False

    eh_animal(())
    # False

    eh_animal([])
    # False

    eh_animal({})
    # False

    eh_animal(((1, 1), 5, 5, 'animal', 'qwerty', 'abc'))
    # False

    eh_animal([(1, 1), 5, 5, 'animal', 'qwerty', 'abc'])
    # False

    a = cria_animal('predator', 10, 5)
    eh_animal(a)
    # True

    a = cria_animal('prey', 10, 0)
    eh_animal(a)
    # True

    a = cria_animal('predator', 10, 5)
    eh_animal(cria_copia_animal(a))
    # True

    return


def teste_eh_predador():
    total_score = 5
    fun_name = eh_predador

    eh_predador([])
    # False

    a = cria_animal('predator', 10, 5)
    eh_predador(a)
    # True

    a = cria_animal('predator', 10, 0)
    eh_predador(a)
    # False

    return



def teste_eh_presa():
    total_score = 5
    fun_name = eh_presa

    eh_presa({})
    # False

    a = cria_animal('presa', 10, 5)
    eh_presa(a)
    # False

    a = cria_animal('presa', 10, 0)
    eh_presa(a)
    # True

    return




def teste_animais_iguais():
    total_score = 25
    fun_name = animais_iguais

    u = cria_animal('lion', 10, 5)
    animais_iguais(u, u)
    # True

    u = cria_animal('lion', 10, 5)
    animais_iguais(u, False)
    # False

    u = cria_animal('lion', 10, 5)
    animais_iguais({}, u)
    # False

    u1 = cria_animal('lion', 10, 5)
    u2 = cria_animal('lion', 10, 5)
    animais_iguais(u1, u2)
    # True

    u = cria_animal('lion', 10, 5)
    c = cria_copia_animal(u)
    animais_iguais(u, c)
    # True

    u = cria_animal('lion', 10, 5)
    t = cria_animal('lion', 5, 5)
    animais_iguais(u, t)
    # False

    u = cria_animal('lion', 10, 5)
    t = cria_animal('leon', 10, 5)
    animais_iguais(u, t)
    # False

    u1 = cria_animal('lion', 10, 5)
    u2 = cria_animal('lion', 10, 0)
    animais_iguais(u1, u2)
    # False

    u1 = cria_animal('lion', 10, 5)
    u2 = cria_animal('lion', 10, 5)
    u1 = aumenta_idade(u1)
    animais_iguais(u1, u2)
    # False

    u1 = cria_animal('lion', 10, 5)
    u2 = cria_animal('lion', 10, 5)
    u3 = aumenta_fome(u2)
    animais_iguais(u1, u2)
    # False

    u1 = cria_animal('koala', 5, 0)
    u2 = cria_animal('koala', 5, 0)
    u1 = aumenta_fome(u2)
    animais_iguais(u1, u2)
    # True

    return


def teste_animal_para_char():
    total_score = 10
    fun_name = animal_para_char

    u1 = cria_animal('koala', 5, 0)
    u2 = cria_animal('KOALA', 5, 0)
    animal_para_char(u1) == 'k' and animal_para_char(u2) == 'k'
    # True

    u1 = cria_animal('tiger', 25, 10)
    u2 = cria_animal('TIGER', 25, 10)
    animal_para_char(u1) == 'T'  and animal_para_char(u2) == 'T'
    # True

    return


def teste_animal_para_str():
    total_score = 15
    fun_name = animal_para_str

    u = cria_animal('TIGER', 25, 10)
    isinstance(animal_para_str(u), str)
    # True

    u = cria_animal('TIGER', 25, 10)
    animal_para_str(u)
    # TIGER [0/25;0/10]

    u = cria_animal('koala', 5, 0)
    animal_para_str(u)
    # koala [0/5]

    return


def teste_eh_animal_fertil():
    total_score = 10
    fun_name = eh_animal_fertil

    a = cria_animal('formiga', 1, 0)
    eh_animal_fertil(a)
    # False

    a = cria_animal('formiga', 1, 0)
    a = aumenta_idade(a)
    eh_animal_fertil(a)
    # True

    a = cria_animal('formiga', 1, 0)
    a = aumenta_idade(a)
    a = reset_idade(a)
    eh_animal_fertil(a)
    # False

    a = cria_animal('aranha', 2, 1)
    a = aumenta_idade(a)
    eh_animal_fertil(a)
    # False

    return


def teste_eh_animal_faminto():
    total_score = 10
    fun_name = eh_animal_faminto

    a = cria_animal('formiga', 1, 0)
    eh_animal_faminto(a)
    # False

    a = cria_animal('formiga', 1, 0)
    a = aumenta_fome(a)
    eh_animal_faminto(a)
    # False

    a = cria_animal('aranha', 2, 1)
    a = aumenta_fome(a)
    eh_animal_faminto(a)
    # True

    a = cria_animal('aranha', 2, 5)
    a = aumenta_fome(a)
    a = aumenta_fome(a)
    eh_animal_faminto(a)
    # False

    return



def teste_reproduz_animal():
    total_score = 15
    fun_name = reproduz_animal

    a = cria_animal('formiga', 1, 0)
    n = reproduz_animal(a)
    id(a) != id(n)  and animais_iguais(a, n)
    # True

    a = cria_animal('aranha', 5, 2)
    a = aumenta_idade(a)
    a = aumenta_fome(a)
    n = reproduz_animal(a)
    obter_idade(a) == obter_idade(n) == 0 and obter_fome(a) == 1 and obter_fome(n) == 0
    # True


    a = cria_animal('aranha', 5, 2)
    a = aumenta_idade(a)
    a = aumenta_fome(a)
    n = reproduz_animal(a)
    obter_especie(a) == obter_especie(n) == 'aranha' and obter_freq_alimentacao(a) == obter_freq_alimentacao(n) == 2 and obter_freq_reproducao(a) == obter_freq_reproducao(n) == 5
    # True

    return



def teste_cria_prado():

    total_score = 50
    fun_name = cria_prado

    d = cria_posicao(1, 1)
    w = ()
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = []
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), 4, cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = (cria_posicao(0, 0), cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(10, 10))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = ()
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = ()
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = list(cria_animal('aguia', 20, 4) for i in range(2)) + list(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2)) + ('ola',)
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    cria_prado(d, w, a, p)
    # cria_prado: argumentos invalidos

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    m == m
    # True

    d = cria_posicao(12, 12)
    w = ()
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 8), (3, 1), (5, 3), (7,7)))
    m = cria_prado(d, w, a, p)
    m == m
    # True

    return


def teste_cria_copia_prado():

    total_score = 15
    fun_name = cria_copia_prado

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a, p)
    m2 = cria_copia_prado(m1)
    id(m1) != id(m2) and prados_iguais(m1, m2)
    # True

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p1 = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    p2 = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 2), (5, 3)))
    m1 = cria_prado(d, w, a, p1)
    m2 = cria_prado(d, w, a, p2)
    prados_iguais(m1, m2)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a1 = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    a2 = tuple(cria_animal('aguia', 20, 4) for i in range(1)) + tuple(cria_animal('lebre', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a1, p)
    m2 = cria_prado(d, w, a2, p)
    prados_iguais(m1, m2)
    # False

    d = cria_posicao(6, 4)
    w1 = (cria_posicao(4, 2), cria_posicao(5, 2))
    w2 = (cria_posicao(5, 2),)
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w1, a, p)
    m2 = cria_prado(d, w2, a, p)
    prados_iguais(m1, m2)
    # False

    return


def teste_obter_tamanho_x():

    total_score = 5
    fun_name = obter_tamanho_x

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    type(obter_tamanho_x(m)) == int and obter_tamanho_x(m) == 7
    # True

    return

def teste_obter_tamanho_y():

    total_score = 5
    fun_name = obter_tamanho_y

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('aguia', 20, 4) for i in range(2)) + tuple(cria_animal('lebre', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    type(obter_tamanho_y(m)) == int and obter_tamanho_y(m) == 5
    # True

    return



def teste_obter_numero_predadores():
    total_score = 15
    fun_name = obter_numero_predadores

    d = cria_posicao(9, 9)
    w = ()
    a = tuple(cria_animal('aguia', 20, 4) for i in range(1)) + tuple(cria_animal('lebre', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    obter_numero_predadores(m) == 1
    # True

    d = cria_posicao(9, 9)
    w = ()
    a = tuple(cria_animal('aguia', 20, 4) for i in range(0)) + tuple(cria_animal('lebre', 10, 0) for i in range(4))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    obter_numero_predadores(m) == 0
    # True

    d = cria_posicao(9, 9)
    w = ()
    a = tuple(cria_animal('aguia', 20, 4) for i in range(4)) + tuple(cria_animal('lebre', 10, 0) for i in range(0))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    obter_numero_predadores(m) == 4
    # True

    return


def teste_obter_numero_presas():
    total_score = 15
    fun_name = obter_numero_presas

    d = cria_posicao(19, 19)
    w = ()
    a = tuple(cria_animal('aguia', 20, 4) for i in range(1)) + tuple(cria_animal('lebre', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    obter_numero_presas(m) == 3
    # True

    d = cria_posicao(9, 12)
    w = ()
    a = tuple(cria_animal('aguia', 20, 4) for i in range(0)) + tuple(cria_animal('lebre', 10, 0) for i in range(4))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    obter_numero_presas(m) == 4
    # True

    d = cria_posicao(12, 9)
    w = ()
    a = tuple(cria_animal('aguia', 20, 4) for i in range(4)) + tuple(cria_animal('lebre', 10, 0) for i in range(0))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    obter_numero_presas(m) == 0
    # True

    return





def teste_obter_posicao_animais():
    total_score = 30
    fun_name = obter_posicao_animais


    d = cria_posicao(19, 11)
    w = ()
    a = tuple(cria_animal('raposa', 20, 4) for i in range(1)) + tuple(cria_animal('rato', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p_a = obter_posicao_animais(m)
    isinstance(p_a, tuple) and len(p_a) == 4 and all(eh_posicao(x) for x in p_a)
    # True


    d = cria_posicao(19, 11)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('raposa', 20, 4) for i in range(1)) + tuple(cria_animal('rato', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p_a = obter_posicao_animais(m)
    isinstance(p_a, tuple) and len(p_a) == 4 and all(eh_posicao(x) for x in p_a)
    # True



    d = cria_posicao(19, 11)
    w = (cria_posicao(4, 2), cria_posicao(5, 2))
    a = tuple(cria_animal('raposa', 20, 4) for i in range(1)) + tuple(cria_animal('rato', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    ', '.join(posicao_para_str(u) for u in obter_posicao_animais(m))
    # (1, 1), (3, 1), (2, 2), (5, 3)

    return


def teste_obter_animal():

    total_score = 15
    fun_name = obter_animal

    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(3,1)
    eh_animal(obter_animal(m, p))
    # True

    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(3,1)
    animais_iguais(obter_animal(m, p), cria_animal('zebra', 10, 0))
    # True

    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(1,1)
    u1 = obter_animal(m, p)
    u2 = obter_animal(m, obter_posicao_animais(m)[0])
    id(u1) != id(u2)
    # False

    return



def teste_eliminar_animal():
    total_score = 15
    fun_name = eliminar_animal

    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    t = eliminar_animal(m, cria_posicao(3,1))
    obter_numero_predadores(m), obter_numero_presas(m)
    # (1, 2)


    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    t = eliminar_animal(m, cria_posicao(3,1))
    ', '.join(posicao_para_str(u) for u in obter_posicao_animais(m))
    # (1, 1), (2, 2), (5, 3)

    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    t = eliminar_animal(m, cria_posicao(3,1))
    eh_posicao_livre(m, cria_posicao(3, 1))
    # True

    return




def teste_mover_animal():
    total_score = 15
    fun_name = mover_animal

    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    t = mover_animal(m, cria_posicao(3,1), cria_posicao(8,8))
    eh_posicao_livre(m, cria_posicao(3, 1)) and eh_posicao_animal(m, cria_posicao(8, 8))
    # True

    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    u1 = obter_animal(m, cria_posicao(2,2))
    v1 = aumenta_idade(u1)
    t = mover_animal(m, cria_posicao(2,2), cria_posicao(8,8))
    u2 = obter_animal(m, cria_posicao(8, 8))
    obter_idade(u2) == 1
    # True

    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    t = mover_animal(m, cria_posicao(3,1), cria_posicao(8,8))
    ', '.join(posicao_para_str(u) for u in obter_posicao_animais(m))
    # (1, 1), (2, 2), (5, 3), (8, 8)


    return


def teste_eh_prado():
    total_score = 25
    fun_name = eh_prado

    eh_prado(())
    # False

    eh_prado([])
    # False

    eh_prado({})
    # False

    eh_prado(True)
    # False

    eh_prado((5,'s'))
    # False

    eh_prado(['f', 'p'])
    # False

    a = cria_animal('predator', 10, 5)
    eh_prado(a)
    # False

    d = cria_posicao(7, 10)
    w = ()
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 7), (1, 6), (3, 6), (5, 9)))
    m = cria_prado(d, w, a, p)
    eh_prado(m)
    # True

    d = cria_posicao(7, 10)
    w = ()
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 7), (1, 6), (3, 6), (5, 9)))
    m = cria_prado(d, w, a, p)
    eh_prado(cria_copia_prado(m))
    # True

    return


def teste_inserir_animal():
    total_score = 20
    fun_name = inserir_animal


    d = cria_posicao(7, 10)
    w = ()
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 7), (1, 6), (3, 6), (5, 9)))
    m = cria_prado(d, w, a, p)
    u1 = cria_animal('pomba', 10, 0)
    u1 = aumenta_idade(aumenta_idade(u1))
    t = inserir_animal(m, u1, cria_posicao(4, 3))
    u2 = obter_animal(m, cria_posicao(4, 3))
    animais_iguais(u1, u2)
    # True


    d = cria_posicao(7, 10)
    w = ()
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 7), (1, 6), (3, 6), (5, 9)))
    m = cria_prado(d, w, a, p)
    u1 = cria_animal('pomba', 10, 0)
    t = inserir_animal(m, u1, cria_posicao(4,3))
    u2 = obter_animal(m, cria_posicao(4,3))
    ', '.join(posicao_para_str(u) for u in obter_posicao_animais(m))
    # (4, 3), (1, 6), (3, 6), (2, 7), (5, 9)


    return


def teste_eh_posicao_animal():
    total_score = 15
    fun_name = eh_posicao_animal

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(1,1)
    eh_posicao_animal(m, p)
    # True

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(6, 4)
    eh_posicao_animal(m, p)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(4, 2)
    eh_posicao_animal(m, p)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(3, 2)
    eh_posicao_animal(m, p)
    # False

    return


def teste_eh_posicao_livre():
    total_score = 15
    fun_name = eh_posicao_livre


    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(1,1)
    eh_posicao_livre(m, p)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(6, 4)
    eh_posicao_livre(m, p)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(4, 2)
    eh_posicao_livre(m, p)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(3, 2)
    eh_posicao_livre(m, p)
    # True

    return


def teste_eh_posicao_obstaculo():
    total_score = 15
    fun_name = eh_posicao_obstaculo

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(1,1)
    eh_posicao_obstaculo(m, p)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(6, 4)
    eh_posicao_obstaculo(m, p)
    # True

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(4, 2)
    eh_posicao_obstaculo(m, p)
    # True

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(3, 2)
    eh_posicao_obstaculo(m, p)
    # False

    return


def teste_prados_iguais():
    total_score = 25
    fun_name = prados_iguais

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    prados_iguais(m, m)
    # True

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a, p)
    m2 = cria_copia_prado(m1)
    prados_iguais(m1, m2)
    # True

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a, p)
    d = cria_posicao(7, 6)
    m2 = cria_prado(d, w, a, p)
    prados_iguais(m1, m2)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a, p)
    w = (cria_posicao(4, 2), cria_posicao(4, 1))
    m2 = cria_prado(d, w, a, p)
    prados_iguais(m1, m2)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a, p)
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1)))
    m2 = cria_prado(d, w, a, p)
    prados_iguais(m1, m2)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a, p)
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (4, 3)))
    m2 = cria_prado(d, w, a, p)
    prados_iguais(m1, m2)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a, p)
    a = tuple(cria_animal('gato', 20, 4) for i in range(2)) + tuple(cria_animal('pombo', 10, 0) for i in range(2))
    m2 = cria_prado(d, w, a, p)
    prados_iguais(m1, m2)
    # False

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m1 = cria_prado(d, w, a, p)
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 12, 0) for i in range(3))
    m2 = cria_prado(d, w, a, p)
    prados_iguais(m1, m2)
    # False

    return


def teste_prado_para_str():
    total_score = 25
    fun_name = prado_para_str

    d = cria_posicao(14, 4)
    w = (cria_posicao(10, 3), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    prado_para_str(m)
    # +-------------+\\n|p.p@.........|\\n|.G...........|\\n|@...p....@...|\\n+-------------+

    d = cria_posicao(5, 14)
    w = (cria_posicao(4, 11), cria_posicao(1, 13), cria_posicao(3, 6), cria_posicao(3, 7),cria_posicao(3, 8))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 8), (1, 12), (3, 4), (4, 7)))
    m = cria_prado(d, w, a, p)
    prado_para_str(m)
    # +----+\\n|....|\\n|....|\\n|....|\\n|..p.|\\n|....|\\n|..@.|\\n|..@p|\\n|.G@.|\\n|....|\\n|....|\\n|...@|\\n|p...|\\n|@...|\\n+----+

    return


def teste_obter_valor_numerico():
    total_score = 20
    fun_name = obter_valor_numerico

    d = cria_posicao(14, 4)
    w = (cria_posicao(10, 3), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    obter_valor_numerico(m, cria_posicao(14, 4))
    # 74

    d = cria_posicao(5, 14)
    w = (cria_posicao(4, 11), cria_posicao(1, 13), cria_posicao(3, 6), cria_posicao(3, 7), cria_posicao(3, 8))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 8), (1, 12), (3, 4), (4, 7)))
    m = cria_prado(d, w, a, p)
    obter_valor_numerico(m, cria_posicao(3, 12))
    # 75

    return


def teste_obter_movimento():
    total_score = 60
    fun_name = obter_movimento

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    posicao_para_str(obter_movimento(m, cria_posicao(2,2)))
    # (2, 1)

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 2), (5, 3)))
    m = cria_prado(d, w, a, p)
    posicao_para_str(obter_movimento(m, cria_posicao(2,2)))
    # (3, 2)


    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 1), (1, 1), (1, 2), (5, 3)))
    m = cria_prado(d, w, a, p)
    posicao_para_str(obter_movimento(m, cria_posicao(1,1)))
    # (1, 1)

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(2)) + tuple(cria_animal('pombo', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((5, 1), (5, 2), (1, 2), (5, 3)))
    m = cria_prado(d, w, a, p)
    posicao_para_str(obter_movimento(m, cria_posicao(5,1)))
    # (5, 1)

    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(2)) + tuple(cria_animal('pombo', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((5, 1), (5, 2), (1, 2), (5, 3)))
    m = cria_prado(d, w, a, p)
    posicao_para_str(obter_movimento(m, cria_posicao(5,2)))
    # (5, 3)


    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(2)) + tuple(cria_animal('pombo', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in ((5, 1), (5, 2), (1, 2), (5, 3)))
    m = cria_prado(d, w, a, p)
    posicao_para_str(obter_movimento(m, cria_posicao(5, 3)))
    # (4, 3)

    return

def geracao():
    total_score = 200
    fun_name = geracao

    d = cria_posicao(7, 7)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('lizzard', 20, 4) for i in range(3)) + tuple(cria_animal('fly', 10, 0) for i in range(5))
    p = tuple(cria_posicao(*p) for p in (((2, 5), (1, 1), (2, 4),(3, 1), (5, 3), (2, 6), (1, 5), (3, 5))))
    m = cria_prado(d, w, a, p)
    t = geracao(m)
    prado_para_str(m)
    # +------+\\n|.f.@..|\\n|L..@..|\\n|@....f|\\n|..L...|\\n|.fL...|\\n|f.....|\\n+------+

    d = cria_posicao(7, 7)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('lizzard', 20, 4) for i in range(3)) + tuple(cria_animal('fly', 10, 0) for i in range(5))
    p = tuple(cria_posicao(*p) for p in (((2, 5), (1, 1), (2, 4),(3, 1), (5, 3), (2, 6), (1, 5), (3, 5))))
    m = cria_prado(d, w, a, p)
    t = geracao(m)
    obter_numero_predadores(m), obter_numero_presas(m)
    # (3, 4)

    d = cria_posicao(7, 7)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('lizzard', 20, 4) for i in range(3)) + tuple(cria_animal('fly', 10, 0) for i in range(5))
    p = tuple(cria_posicao(*p) for p in (((2, 5), (1, 1), (2, 4),(3, 1), (5, 3), (2, 6), (1, 5), (3, 5))))
    m = cria_prado(d, w, a, p)
    t = geracao(m)
    obter_fome(obter_animal(m, cria_posicao(3, 5))) == 0
    # True

    d = cria_posicao(7, 7)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('lizzard', 20, 4) for i in range(3)) + tuple(cria_animal('fly', 10, 0) for i in range(5))
    p = tuple(cria_posicao(*p) for p in (((2, 5), (1, 1), (2, 4),(3, 1), (5, 3), (2, 6), (1, 5), (3, 5))))
    m = cria_prado(d, w, a, p)
    t = geracao(m)
    all(obter_idade(obter_animal(m, p)) == 1 for p in obter_posicao_animais(m))
    # True

    d = cria_posicao(7, 7)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('lizzard', 20, 4) for i in range(3)) + tuple(cria_animal('fly', 10, 0) for i in range(5))
    p = tuple(cria_posicao(*p) for p in (((2, 5), (1, 1), (2, 4),(3, 1), (5, 3), (2, 6), (1, 5), (3, 5))))
    m = cria_prado(d, w, a, p)
    t = geracao(m)
    obter_fome(obter_animal(m, cria_posicao(3, 4))) == 1
    # True

    d = cria_posicao(9, 9)
    w = ()
    a = tuple(cria_animal('lizzard', 20, 4) for i in range(2)) + tuple(cria_animal('fly', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in (((2, 2), (1, 8), (3, 1), (5, 3), (7, 7))))
    m = cria_prado(d, w, a, p)
    t = geracao(m)
    prado_para_str(m)
    # +--------+\\n|........|\\n|..L.....|\\n|...f....|\\n|........|\\n|........|\\n|........|\\n|.......f|\\n|.L......|\\n+--------+

    d = cria_posicao(5, 14)
    w = (cria_posicao(4, 11), cria_posicao(1, 13), cria_posicao(3, 6), cria_posicao(3, 7), cria_posicao(3, 8))
    a = tuple(cria_animal('lizzard', 20, 4) for i in range(2)) + tuple(cria_animal('fly', 10, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in (((2, 8), (1, 12),(3, 4), (4, 7))))
    m = cria_prado(d, w, a, p)
    t = geracao(m)
    prado_para_str(m)
    # +----+\\n|....|\\n|....|\\n|....|\\n|.f..|\\n|....|\\n|..@f|\\n|..@.|\\n|L.@.|\\n|....|\\n|....|\\n|...@|\\n|.L..|\\n|@...|\\n+----+

    d = cria_posicao(5, 5)
    w = (cria_posicao(1, 3), cria_posicao(2, 3), cria_posicao(3, 4))
    a = tuple(cria_animal('lizzard', 5, 2) for i in range(2)) + tuple(cria_animal('fly', 2, 0) for i in range(2))
    p = tuple(cria_posicao(*p) for p in (((2, 4), (3, 1),(3, 3), (1,4))))
    m = cria_prado(d, w, a, p)
    t = geracao(geracao(m))
    prado_para_str(m)
    # +----+\\n|....|\\n|....|\\n|@@.f|\\n|.L@f|\\n+----+

    return


def teste_simula_ecossistema():
    total_score = 200
    fun_name = simula_ecossistema

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config1.txt', 30, True)
    # Predadores: 1 vs Presas: 2 (Gen. 0)\n+------+\n|L.....|\n|.r....|\n|...r..|\n|......|\n+------+\nPredadores: 1 vs Presas: 1 (Gen. 2)\n+------+\n|...r..|\n|.L....|\n|......|\n|......|\n+------+\nPredadores: 1 vs Presas: 2 (Gen. 5)\n+------+\n|......|\n|....rr|\n|......|\n|..L...|\n+------+\nPredadores: 0 vs Presas: 2 (Gen. 6)\n+------+\n|....r.|\n|......|\n|.....r|\n|......|\n+------+\nPredadores: 0 vs Presas: 4 (Gen. 10)\n+------+\n|....rr|\n|....rr|\n|......|\n|......|\n+------+\nPredadores: 0 vs Presas: 8 (Gen. 15)\n+------+\n|.rr.rr|\n|....rr|\n|.r....|\n|.r....|\n+------+\nPredadores: 0 vs Presas: 16 (Gen. 20)\n+------+\n|.rr.rr|\n|.rr.rr|\n|.rrrr.|\n|.rrrr.|\n+------+\nPredadores: 0 vs Presas: 24 (Gen. 25)\n+------+\n|rrrrrr|\n|rrrrrr|\n|rrrrrr|\n|rrrrrr|\n+------+\n(0, 24)

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config1.txt', 5, False)
    # Predadores: 1 vs Presas: 2 (Gen. 0)\n+------+\n|L.....|\n|.r....|\n|...r..|\n|......|\n+------+\nPredadores: 1 vs Presas: 2 (Gen. 5)\n+------+\n|......|\n|....rr|\n|......|\n|..L...|\n+------+\n(1, 2)

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config2.txt', 50, True)
    # Predadores: 2 vs Presas: 2 (Gen. 0)\n+------+\n|L.....|\n|.L....|\n|..rr..|\n|......|\n+------+\nPredadores: 2 vs Presas: 1 (Gen. 4)\n+------+\n|......|\n|.L..r.|\n|......|\n|.L....|\n+------+\nPredadores: 2 vs Presas: 2 (Gen. 5)\n+------+\n|......|\n|....rr|\n|.L....|\n|..L...|\n+------+\nPredadores: 1 vs Presas: 2 (Gen. 6)\n+------+\n|....r.|\n|......|\n|.....r|\n|.L....|\n+------+\nPredadores: 1 vs Presas: 4 (Gen. 10)\n+------+\n|....rr|\n|....rr|\n|......|\n|..L...|\n+------+\nPredadores: 1 vs Presas: 3 (Gen. 14)\n+------+\n|..r...|\n|....rr|\n|.L....|\n|......|\n+------+\nPredadores: 1 vs Presas: 6 (Gen. 15)\n+------+\n|.rr.rr|\n|....rr|\n|......|\n|.L....|\n+------+\nPredadores: 1 vs Presas: 5 (Gen. 19)\n+------+\n|......|\n|.rr.rr|\n|.r....|\n|...L..|\n+------+\nPredadores: 2 vs Presas: 10 (Gen. 20)\n+------+\n|.r...r|\n|.rrrrr|\n|rr.Lr.|\n|...L..|\n+------+\nPredadores: 2 vs Presas: 8 (Gen. 21)\n+------+\n|.rrrr.|\n|.r.L..|\n|r..L.r|\n|r.....|\n+------+\nPredadores: 2 vs Presas: 7 (Gen. 22)\n+------+\n|rrr...|\n|..rLLr|\n|.r....|\n|.r....|\n+------+\nPredadores: 2 vs Presas: 6 (Gen. 23)\n+------+\n|.r....|\n|rrL..L|\n|r.r...|\n|..r...|\n+------+\nPredadores: 2 vs Presas: 5 (Gen. 24)\n+------+\n|rrr...|\n|......|\n|.rL..L|\n|.r....|\n+------+\nPredadores: 2 vs Presas: 9 (Gen. 25)\n+------+\n|rrr...|\n|rrr..L|\n|rL....|\n|.rr...|\n+------+\nPredadores: 2 vs Presas: 8 (Gen. 26)\n+------+\n|rr.r..|\n|rL.r..|\n|.r...L|\n|rr....|\n+------+\nPredadores: 2 vs Presas: 7 (Gen. 27)\n+------+\n|r.rrr.|\n|.....L|\n|rL....|\n|r.r...|\n+------+\nPredadores: 2 vs Presas: 5 (Gen. 28)\n+------+\n|.r....|\n|r..rL.|\n|L.....|\n|.r.r..|\n+------+\nPredadores: 4 vs Presas: 9 (Gen. 30)\n+------+\n|rr....|\n|rLrr.L|\n|.L.r.L|\n|.rrr..|\n+------+\nPredadores: 4 vs Presas: 6 (Gen. 31)\n+------+\n|r.rr.L|\n|..L...|\n|r.rrL.|\n|.L....|\n+------+\nPredadores: 4 vs Presas: 3 (Gen. 32)\n+------+\n|.r..L.|\n|r..r..|\n|..L..L|\n|L.....|\n+------+\nPredadores: 4 vs Presas: 1 (Gen. 33)\n+------+\n|......|\n|.rL.LL|\n|L.....|\n|......|\n+------+\nPredadores: 4 vs Presas: 0 (Gen. 36)\n+------+\n|..L.L.|\n|......|\n|.....L|\n|..L...|\n+------+\nPredadores: 3 vs Presas: 0 (Gen. 37)\n+------+\n|.L....|\n|....L.|\n|......|\n|.L....|\n+------+\nPredadores: 2 vs Presas: 0 (Gen. 38)\n+------+\n|......|\n|.L....|\n|......|\n|..L...|\n+------+\nPredadores: 1 vs Presas: 0 (Gen. 39)\n+------+\n|......|\n|......|\n|.L....|\n|......|\n+------+\nPredadores: 2 vs Presas: 0 (Gen. 40)\n+------+\n|......|\n|......|\n|.L....|\n|.L....|\n+------+\nPredadores: 1 vs Presas: 0 (Gen. 42)\n+------+\n|......|\n|......|\n|.L....|\n|......|\n+------+\nPredadores: 0 vs Presas: 0 (Gen. 46)\n+------+\n|......|\n|......|\n|......|\n|......|\n+------+\n(0, 0)

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config2.txt', 25, False)
    # Predadores: 2 vs Presas: 2 (Gen. 0)\n+------+\n|L.....|\n|.L....|\n|..rr..|\n|......|\n+------+\nPredadores: 2 vs Presas: 9 (Gen. 25)\n+------+\n|rrr...|\n|rrr..L|\n|rL....|\n|.rr...|\n+------+\n(2, 9)

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config3.txt', 20, True)
    # Predadores: 1 vs Presas: 8 (Gen. 0)\n+-------+\n|r..r..r|\n|.......|\n|.......|\n|r..F..r|\n|.......|\n|.......|\n|r..r..r|\n+-------+\nPredadores: 1 vs Presas: 7 (Gen. 6)\n+-------+\n|r......|\n|r......|\n|......r|\n|.Fr...r|\n|.......|\n|.......|\n|...r..r|\n+-------+\nPredadores: 1 vs Presas: 6 (Gen. 7)\n+-------+\n|.r.....|\n|.r....r|\n|.......|\n|..F....|\n|......r|\n|......r|\n|....r..|\n+-------+\nPredadores: 1 vs Presas: 12 (Gen. 8)\n+-------+\n|rr.....|\n|rr....r|\n|......r|\n|.F....r|\n|......r|\n|.....rr|\n|...rr..|\n+-------+\nPredadores: 2 vs Presas: 12 (Gen. 15)\n+-------+\n|r.....r|\n|r..r...|\n|.....r.|\n|...r..r|\n|FF...r.|\n|...r.r.|\n|...r..r|\n+-------+\nPredadores: 2 vs Presas: 24 (Gen. 16)\n+-------+\n|rr....r|\n|r..r..r|\n|r..r.rr|\n|F..r.rr|\n|F..rrr.|\n|...rrrr|\n|..rr.rr|\n+-------+\nPredadores: 1 vs Presas: 24 (Gen. 17)\n+-------+\n|r....r.|\n|rr..rrr|\n|.r..rr.|\n|.F..rr.|\n|..rrrrr|\n|..rr.rr|\n|.rr.r..|\n+-------+\nPredadores: 1 vs Presas: 23 (Gen. 19)\n+-------+\n|r..r..r|\n|.rrrrrr|\n|.r.r...|\n|.rr.rr.|\n|...r..r|\n|rF.r..r|\n|..rrr..|\n+-------+\n(1, 23)

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config3.txt', 10, False)
    # Predadores: 1 vs Presas: 8 (Gen. 0)\n+-------+\n|r..r..r|\n|.......|\n|.......|\n|r..F..r|\n|.......|\n|.......|\n|r..r..r|\n+-------+\nPredadores: 1 vs Presas: 12 (Gen. 10)\n+-------+\n|r..r.r.|\n|r......|\n|.r...rr|\n|.....r.|\n|F.....r|\n|..r...r|\n|....r..|\n+-------+\n(1, 12)

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config4.txt', 15, False)
    # Predadores: 2 vs Presas: 4 (Gen. 0)\n+-----+\n|.s...|\n|...Ws|\n|.@.@s|\n|..s@W|\n|.....|\n+-----+\nPredadores: 1 vs Presas: 2 (Gen. 15)\n+-----+\n|...W.|\n|.....|\n|.@.@.|\n|...@.|\n|ss...|\n+-----+\n(1, 2)

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config5.txt', 25, False)
    # Predadores: 2 vs Presas: 3 (Gen. 0)\n+----+\n|..g.|\n|E...|\n|@@g.|\n|gE@.|\n+----+\nPredadores: 2 vs Presas: 3 (Gen. 25)\n+----+\n|Egg.|\n|..g.|\n|@@.E|\n|..@.|\n+----+\n(2, 3)

    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'private_test_config6.txt', 20, False)
    # Predadores: 10 vs Presas: 20 (Gen. 0)\n+------------------------------+\n|@@@@@@@@@@@@@@@@@@........@@@@|\n|@@@@@@@@@@@@@@@@@@..m..@m..@@@|\n|@@@@@@@@@@@@@@@@@@@........@@@|\n|@..m@@@@@@@@@@@@@@@m......@@@@|\n|@@..m@@@@@@@@@@@@@@@.....@@@@@|\n|@@@@.@@@@@@..@@@@@@....m@@..@@|\n|@@@@.........@@@@............@|\n|@@@@@@@@...@@@@@.............@|\n|@@@@@@@@...@@@@..............@|\n|@@@@@@@@T@@@@@.......mT......@|\n|@@@@@@@@............T...m...@@|\n|@@@@@.@@@....@@@@@..m........@|\n|.m@....@@...@@@@@@@.........@@|\n|@.@....@@mm@@@@@@@@@.........@|\n|....m@....T@@@@@@@@@....@....@|\n|...........@@@@@@@@@.......@@@|\n|@@@@..m....@@@@@@@@@...@@....@|\n|@@@@....m..@@@@@@@@@.@.......@|\n|@@@@@@...m..@@@@@@@m.....@...@|\n|@@@@@....T...@@@@@............|\n|@@@@@...mm.......T......@...T.|\n|@@@@@@.m...@....@..@...@.....@|\n|@@@@@@..........@@@@@..@@@@.@@|\n|@@@@@@@.......T@@@@@@@@@@@@@@@|\n|@@@@@@..........@@@@@@@@@@@@@@|\n|@@@@@@@.............@@@@@@@@@@|\n|@@@@@@@@...@...@@....@@@@@@@@@|\n|@@@@@@@@.....@.@..T..@@@@@@@@@|\n|@@@@@@@@@@@@@@@.....@@@@@@@@@@|\n|@@@@@@@@@@@@@@@.@@T.@@@@@@@@@@|\n+------------------------------+\nPredadores: 2 vs Presas: 57 (Gen. 20)\n+------------------------------+\n|@@@@@@@@@@@@@@@@@@mm......@@@@|\n|@@@@@@@@@@@@@@@@@@..m..@...@@@|\n|@@@@@@@@@@@@@@@@@@@...m....@@@|\n|@mmm@@@@@@@@@@@@@@@m..m.mm@@@@|\n|@@mm.@@@@@@@@@@@@@@@.m...@@@@@|\n|@@@@.@@@@@@..@@@@@@.....@@..@@|\n|@@@@..m.m....@@@@............@|\n|@@@@@@@@...@@@@@.....m.m.....@|\n|@@@@@@@@m..@@@@......m.......@|\n|@@@@@@@@.@@@@@........m......@|\n|@@@@@@@@.............m.m....@@|\n|@@@@@.@@@TT..@@@@@...m.......@|\n|..@m...@@...@@@@@@@...m.....@@|\n|@m@m.m.@@.m@@@@@@@@@...m.m...@|\n|mm..m@.m...@@@@@@@@@.m..@....@|\n|mm.m..m.m..@@@@@@@@@.....mm@@@|\n|@@@@mmm....@@@@@@@@@m..@@....@|\n|@@@@.....m.@@@@@@@@@.@..m....@|\n|@@@@@@......@@@@@@@...m..@...@|\n|@@@@@......m.@@@@@..m.........|\n|@@@@@....m............m.@.....|\n|@@@@@@....m@....@..@...@.....@|\n|@@@@@@..........@@@@@m.@@@@.@@|\n|@@@@@@@........@@@@@@@@@@@@@@@|\n|@@@@@@..........@@@@@@@@@@@@@@|\n|@@@@@@@.............@@@@@@@@@@|\n|@@@@@@@@...@...@@....@@@@@@@@@|\n|@@@@@@@@.....@.@.....@@@@@@@@@|\n|@@@@@@@@@@@@@@@.....@@@@@@@@@@|\n|@@@@@@@@@@@@@@@.@@..@@@@@@@@@@|\n+------------------------------+\n(2, 57)

    return
