class AnimalXYZ:
    def __init__(self, s, r, a):
        self.especie = s
        self.repr_ciclo = r
        self.alim_ciclo = a 
        self.fome = 0
        self.idade = 0

def cria_animal(s, r, a):
    if isinstance(s, str) and len(s) > 0 and type(r) == int and r > 0 and type(a) == int and a >= 0:
        return AnimalXYZ(s, r, a)

    raise ValueError('cria_animal: argumentos invalidos')

def cria_copia_animal(a):
    a2 = AnimalXYZ(a.especie, a.repr_ciclo, a.alim_ciclo)
    a2.fome = a.fome
    a2.idade = a.idade
    return a2

def obter_especie(a):
    return a.especie

def obter_freq_reproducao(a):
    return a.repr_ciclo


def obter_freq_alimentacao(a):
    return a.alim_ciclo

def obter_fome(a):
    return a.fome if eh_predador(a) else 0

def obter_idade(a):
    return a.idade

def aumenta_idade(a):
    a.idade += 1
    return a

def reset_idade(a):
    a.idade = 0
    return a


def aumenta_fome(a):
    if eh_predador(a):
        a.fome += 1
    return a

def reset_fome(a):
    a.fome = 0
    return a


def eh_animal(animal):
    return isinstance(animal, AnimalXYZ)


def eh_predador(a):
    return eh_animal(a) and obter_freq_alimentacao(a) > 0


def eh_presa(a):
    return eh_animal(a) and obter_freq_alimentacao(a) == 0

def animais_iguais(a1, a2):
    return eh_animal(a1) and eh_animal(a2) and obter_especie(a1) == obter_especie(a2) and \
           obter_freq_alimentacao(a1) == obter_freq_alimentacao(a2) and \
           obter_freq_reproducao(a1) == obter_freq_reproducao(a2) and \
           obter_fome(a1) == obter_fome(a2) and \
           obter_idade(a1) == obter_idade(a2)

def animal_para_char(a):
    return obter_especie(a)[0].lower() if eh_presa(a) else obter_especie(a)[0].upper()

def animal_para_str(a):
    return '{} [{}/{}]'.format(obter_especie(a), obter_idade(a), obter_freq_reproducao(a)) if eh_presa(a) else \
        '{} [{}/{};{}/{}]'.format(obter_especie(a), obter_idade(a), obter_freq_reproducao(a), obter_fome(a), obter_freq_alimentacao(a))



def eh_animal_fertil(a):
    return obter_idade(a) >= obter_freq_reproducao(a)

def eh_animal_faminto(a):
    return (not eh_presa(a)) and obter_fome(a) >= obter_freq_alimentacao(a)

def reproduz_animal(a):
    reset_idade(a)
    return cria_animal(obter_especie(a), obter_freq_reproducao(a), obter_freq_alimentacao(a))

