from random import randint

def cria_prado(d, r, a, p):
    if eh_posicao(d) and obter_pos_x(d) >=2 and obter_pos_y(d) >=2:
        max_x, max_y = obter_pos_x(d)+1, obter_pos_y(d)+1
        if isinstance(r, tuple) and all(eh_posicao(i) and 0 < obter_pos_x(i) < max_x-1 and 0 < obter_pos_y(i) < max_y -1 for i in r):
            if isinstance(a, tuple) and isinstance(p, tuple) and len(a) == len(p) and len(a) > 0 and \
                    all(eh_animal(i) for i in a) and all(eh_posicao(i) for i in p):
                prado = {'dim': (max_x,  max_y), 'map':{}}
                for i in r:
                    prado['map'][posicao_para_str(i)] = '@'
                for i, j in zip(p, a):
                    prado['map'][posicao_para_str(i)] = j
                return (prado, 'blob', randint(0, 10**6))

    raise ValueError('cria_prado: argumentos invalidos')


def cria_copia_prado(m):
    prado = {'dim': (obter_tamanho_x(m), obter_tamanho_y(m)),
            'map': dict((k, cria_copia_animal(v) if eh_animal(v) else '@') for k, v in m[0]['map'].items())}
    return (prado, 'blob', randint(0, 10**6))

def obter_tamanho_x(m):
    m = m[0]
    return m['dim'][0]

def obter_tamanho_y(m):
    m = m[0]
    return m['dim'][1]

def obter_numero_predadores(m):
    m = m[0]
    return len([1 for e in m['map'].values() if eh_predador(e)])

def obter_numero_presas(m):
    m = m[0]
    return len([1 for e in m['map'].values() if eh_presa(e)])

def obter_posicao_animais(m):
    def str_to_posicao(s):
        return cria_posicao(*eval(s))

    m = m[0]
    return ordenar_posicoes(tuple(str_to_posicao(pos) for pos, val in m['map'].items() if eh_animal(val)))

def obter_animal(m, p):
    m = m[0]
    return m['map'][posicao_para_str(p)]

def eliminar_animal(m, p):
    del m[0]['map'][posicao_para_str(p)]
    return m

def mover_animal(m, p1, p2):
    m[0]['map'][posicao_para_str(p2)] = m[0]['map'][posicao_para_str(p1)]
    del m[0]['map'][posicao_para_str(p1)]
    return m

def inserir_animal(m, a, p):
    m[0]['map'][posicao_para_str(p)] = a
    return m

def eh_posicao_animal(m, p):
    m = m[0]
    return posicao_para_str(p) in m['map'] and eh_animal(m['map'][posicao_para_str(p)])

def eh_posicao_obstaculo(m, p):
    return (posicao_para_str(p) in m[0]['map'] and not eh_animal(m[0]['map'][posicao_para_str(p)])) or \
           obter_pos_x(p) == 0 or obter_pos_x(p) == obter_tamanho_x(m) - 1 or \
           obter_pos_y(p) == 0 or obter_pos_y(p) == obter_tamanho_y(m) - 1

def eh_posicao_livre(m, p):
    return posicao_para_str(p) not in m[0]['map']  and \
           0 < obter_pos_x(p) < obter_tamanho_x(m) - 1 and \
           0 < obter_pos_y(p) < obter_tamanho_y(m) - 1

def eh_prado(m):
    if isinstance(m, tuple) and len(m) == 3 and m[1] == 'blob' and type(m[2]) == int:
        m = m[0] 
        return isinstance(m, dict) and len(m) == 2 and 'dim' in m and 'map' in m and \
           isinstance(m['dim'], tuple) and len(m['dim']) == 2 and \
           type(m['dim'][0]) == int and m['dim'][0] >= 3 and \
           type(m['dim'][1]) == int and m['dim'][1] >= 3 and \
           isinstance(m['map'], dict) and all(eh_animal(m['map'][v]) or m['map'][v] == '@' for v in m['map'])
    return False

def prados_iguais(m1, m2):
    if eh_prado(m1) and eh_prado(m2):
        m1, m2 = m1[0], m2[0]
        return m1['dim'] == m2['dim'] and len(m1['map']) == len(m2['map']) \
           and all(k in m2['map'] for k in m1['map']) and \
           all(eh_animal(m2['map'][k]) if eh_animal(m1['map'][k]) else not eh_animal(m2['map'][k]) for k in m1['map']) \
           and all(animais_iguais(m1['map'][k], m2['map'][k]) for k in m1['map'] if eh_animal(m1['map'][k]))
    return False

def prado_para_str(m):
    mapa_str = '+' + '-'*(obter_tamanho_x(m) - 2) + '+\n'
    for y in range(1, obter_tamanho_y(m)-1):
        mapa_str += '|'
        for x in range(1, obter_tamanho_x(m)-1):
            p = posicao_para_str(cria_posicao(x, y))
            if p in m[0]['map']:
                mapa_str += animal_para_char(m[0]['map'][p]) if eh_animal(m[0]['map'][p]) else '@'
            else:
                mapa_str += '.'
        mapa_str += '|\n'

    mapa_str += '+' + '-' * (obter_tamanho_x(m) - 2) + '+'
    return mapa_str


def obter_valor_numerico(m, p):
    return obter_tamanho_x(m)*obter_pos_y(p) + obter_pos_x(p)

def obter_movimento(m, p):
    if eh_presa(obter_animal(m, p)):
        candidates = [x for x in obter_posicoes_adjacentes(p) if eh_posicao_livre(m, x)]
    else:
        candidates = [x for x in obter_posicoes_adjacentes(p) if eh_posicao_animal(m, x) and eh_presa(obter_animal(m, x))]
        if len(candidates) == 0:
            candidates = [x for x in obter_posicoes_adjacentes(p) if eh_posicao_livre(m, x)]
    return p if not len(candidates) else candidates[obter_valor_numerico(m,p)%len(candidates)]

